// SimpleTextFileDoc.cpp : implementation of the CSimpleTextFileDoc class
//

#include "stdafx.h"
#include "SimpleTextFile.h"

#include "SimpleTextFileDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSimpleTextFileDoc

IMPLEMENT_DYNCREATE(CSimpleTextFileDoc, CDocument)

BEGIN_MESSAGE_MAP(CSimpleTextFileDoc, CDocument)
	ON_COMMAND(ID_FILE_TEXTIMPORT, &CSimpleTextFileDoc::OnFileImport)
	ON_COMMAND(ID_FILE_TEXTEXPORT, &CSimpleTextFileDoc::OnFileExport)
END_MESSAGE_MAP()


// CSimpleTextFileDoc construction/destruction

CSimpleTextFileDoc::CSimpleTextFileDoc()
{
	// TODO: add one-time construction code here

}

CSimpleTextFileDoc::~CSimpleTextFileDoc()
{
}

BOOL CSimpleTextFileDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	m_str = "";
	m_color = RGB(0, 0, 0);

	return TRUE;
}




// CSimpleTextFileDoc serialization

void CSimpleTextFileDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar << m_str << m_color;
	}
	else
	{
		// TODO: add loading code here
		ar >> m_str >> m_color;
	}
}


// CSimpleTextFileDoc diagnostics

#ifdef _DEBUG
void CSimpleTextFileDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSimpleTextFileDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

void CSimpleTextFileDoc::OnFileImport() 
{
	// TODO: Add your command handler code here
	char szFilter[] = "Text File (*.txt)|*.txt|All Files(*.*)|*.*||";
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);
	if(IDOK == dlg.DoModal()) {
		TRY {		
			CFile file(dlg.GetPathName(), CFile::modeRead);
			DWORD dwLength = file.GetLength();
			BYTE *pBuffer = new BYTE[dwLength];
			if (pBuffer) {
				if (file.Read(pBuffer, dwLength) == dwLength) {
					m_str = CString((LPCTSTR)pBuffer, dwLength);
					UpdateAllViews(NULL);
				}
				delete pBuffer;
			}
		}
		CATCH(CFileException, e) {
			e->ReportError();
		}
		END_CATCH
	}
}

void CSimpleTextFileDoc::OnFileExport() 
{
	// TODO: Add your command handler code here
	char szFilter[] = "Text File (*.txt)|*.txt|All Files(*.*)|*.*||";
	CFileDialog dlg(FALSE, "txt", NULL, OFN_HIDEREADONLY, szFilter);
	if(IDOK == dlg.DoModal()) {
		CFile file;
		if (file.Open(dlg.GetPathName(), CFile::modeWrite|CFile::modeCreate) != 0) {
			DWORD dwLength = m_str.GetLength();
			LPTSTR pBuffer = m_str.LockBuffer();
			if (pBuffer && lstrlen(pBuffer) > 0) {
				file.Write(pBuffer, dwLength);
				m_str.UnlockBuffer();
			}
		}
	}	
}
