// SimpleTextFileView.cpp : implementation of the CSimpleTextFileView class
//

#include "stdafx.h"
#include "SimpleTextFile.h"

#include "SimpleTextFileDoc.h"
#include "SimpleTextFileView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSimpleTextFileView

IMPLEMENT_DYNCREATE(CSimpleTextFileView, CView)

BEGIN_MESSAGE_MAP(CSimpleTextFileView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_COMMAND(ID_BUTTON_RED, &CSimpleTextFileView::OnColorRed)
	ON_COMMAND(ID_BUTTON_GREEN, &CSimpleTextFileView::OnColorGreen)
	ON_COMMAND(ID_BUTTON_BLUE, &CSimpleTextFileView::OnColorBlue)
	ON_WM_CHAR()
END_MESSAGE_MAP()

// CSimpleTextFileView construction/destruction

CSimpleTextFileView::CSimpleTextFileView()
{
	// TODO: add construction code here
	m_font.CreatePointFont(400, "Arial");
}

CSimpleTextFileView::~CSimpleTextFileView()
{
}

BOOL CSimpleTextFileView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CSimpleTextFileView drawing

void CSimpleTextFileView::OnDraw(CDC* pDC)
{
	CSimpleTextFileDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
	pDC->SelectObject(&m_font);
	pDC->SetTextColor(pDoc->m_color);
	CRect rect;
	GetClientRect(&rect);
	pDC->DrawText(pDoc->m_str, &rect, DT_LEFT);
}


// CSimpleTextFileView printing

BOOL CSimpleTextFileView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSimpleTextFileView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSimpleTextFileView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CSimpleTextFileView diagnostics

#ifdef _DEBUG
void CSimpleTextFileView::AssertValid() const
{
	CView::AssertValid();
}

void CSimpleTextFileView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSimpleTextFileDoc* CSimpleTextFileView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimpleTextFileDoc)));
	return (CSimpleTextFileDoc*)m_pDocument;
}
#endif //_DEBUG


// CSimpleTextFileView message handlers
void CSimpleTextFileView::OnColorRed() 
{
	CSimpleTextFileDoc* pDoc = GetDocument();
	pDoc->m_color = RGB(255, 0, 0);
	pDoc->SetModifiedFlag();
	Invalidate();
}

void CSimpleTextFileView::OnColorGreen() 
{
	CSimpleTextFileDoc* pDoc = GetDocument();
	pDoc->m_color = RGB(0, 255, 0);
	pDoc->SetModifiedFlag();
	Invalidate();
}

void CSimpleTextFileView::OnColorBlue() 
{
	CSimpleTextFileDoc* pDoc = GetDocument();
	pDoc->m_color = RGB(0, 0, 255);
	pDoc->SetModifiedFlag();
	Invalidate();
}

void CSimpleTextFileView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CSimpleTextFileDoc* pDoc = GetDocument();
	pDoc->m_str += (char) nChar;
	pDoc->SetModifiedFlag();
	Invalidate();
	
	CView::OnChar(nChar, nRepCnt, nFlags);
}
